#! /usr/bin/perl -w
# nw monitor
use strict;

#send initial email to indicate the program/computer has been restarted
sendMail(" Warning from DIP nameserver monitor", "The DIP nameserver monitor program on vodip01 has just started - this indicates that vodip01 has been restarted");

while (1 == 1){
  #A variable that counts the number of cussesive failures before restarting the local DNS instance.
  my $errorCounter = 0;
  my $childID = fork();
  if ($childID == 0){
    #this is the child process
    my @args = ("/home/DIP/dns -d");
    exec(@args);
  }else{
    #this is parent process
    my $shouldExit = 0;
    while ($shouldExit == 0){
      sleep 60;
      #delete previous count file
      my $ns1Count = getNSCount("runDIPNS1Count");
      logMessage("DipNS1 has status: $ns1Count (1=OK, -1=NOK)");
	if ($ns1Count == -1 ){
		$errorCounter = ($errorCounter + 1);
		logMessage("DIP DNS 1 Warning no. $errorCounter.");
		if ($errorCounter < 3) {
			#sendMail("DIP DNS 1 Warning no. $errorCounter" , "The primary DIP nameserver on vodip01 has stopped responding, warning occurence no. $errorCounter ");
		} else {
			$errorCounter = 0;
		        sendMail("DIP DNS 1 Error" , "The primary DIP nameserver on vodip01 has stopped responding - restarting, please look at this.");
                        my @args = ("/usr/sbin/logrotate /home/DIP/logRotateConfigEmergency");
                       system @args;
                	kill 9, $childID;
			$shouldExit = 1;
		}
	} else {
		#Reset the error counter if this time everything went fine.
		if ($errorCounter > 0 ) {
			$errorCounter = 0;
		}
	}
    } # loop until should exit
  }   #parent process
}     #loop for infinity

#param 0 - the script name that should be run
#note that the script should write the number of items in the namespace to the file nsCount.txt
# returns the number of items or -1 if failed
sub getNSCount{
  	#delete previous count file
      my $countFileName = "nsCount.txt";
      unlink($countFileName);

      my $scriptToRun = "/home/DIP/$_[0]";
      logMessage("About to run  $scriptToRun");
      #run publication count program - this program writes an output containing the count to nsCount.txt
      my @args = ($scriptToRun);
      system @args;

      #get result from file
      if (open(INFILE, $countFileName)){
      	my @lines = <INFILE>;
      	close(INFILE);
	 if ($lines[0] != 0){
		$lines[0];
      	} else {
		-1;
	}
      } else{
      		-1;
      }
}


# param 0 the message to log
sub logMessage
{
	(my $sec, my $min, my $hr, my $dom, my $mon, my $yearOffSet, my $dow, my $doy, my $dls) = localtime();
	$mon = $mon + 1;
	$yearOffSet = $yearOffSet + 1900;
	print "$yearOffSet-$mon-$dom $hr.$min.$sec --- $_[0]\n";
}

# param 0 is the subject line
#param 1 is the message body.
sub sendMail
{
	logMessage("Mailing message - $_[1]");
        open(MAIL,"|/usr/lib/sendmail -f \"itco-dip-admins\@cern.ch\" -t");
        print MAIL "To: itco-dip-admins\@cern.ch\n";
        print MAIL "Subject: $_[0]\n";
        print MAIL "$_[1]\n";
        close (MAIL);
}

