#! /usr/bin/perl -w
# nw monitor
use strict; 

#send initial email to indicate the program/computer has been restarted.
sendMail(" Info from DIP nameserver monitor on vodip02", "The DIP nameserver monitor program on vodip02 has just started - this indicates that vodip02 has been restarted");

while (1 == 1){
  #A variable that counts the number of cussesive failures before restarting the local DNS instance.
  my $errorCounter1 = 0;
  my $errorCounter2 = 0;

  my $childID = fork();
  if ($childID == 0){
    #this is the child process
    my @args = ("/home/DIP/dns -d");
    exec(@args);
  }else{
    #this is parent process
    my $shouldExit = 0;
    while ($shouldExit == 0){
      sleep 60;
      #delete previous count file
      my $ns1Count = getNSCount("runDIPNS1Count");
      my $ns2Count = getNSCount("runDIPNS2Count");
      logMessage("DipNS1 has status: $ns1Count (1=OK, -1=NOK) and DipNS2 has $ns2Count DIP Publications.");
      if ($ns1Count == -1) {
	$errorCounter1 = ($errorCounter1 + 1);
	logMessage("DIP DNS 1 Warning no. $errorCounter1.");
	if ($errorCounter1 == 3) {
		$errorCounter1 = 0;
		logMessage("DIP DNS 1 Error : The Primary DIP nameserver on vodip01 failed 3 times to correct probing.");
		sendMail("DIP DNS 1 Error", "The monitoring process on vodip02 indicates the Primary DIP nameserver on vodip01 has stopped responding - please look at this.");
        	my @args = ("/usr/sbin/logrotate /home/DIP/logRotateConfigEmergency");
        	system @args;
		if ($ns2Count == -1){
                	sendMail("DIP DNS 2 Error", "The monitoring process on vodip02 indicates the Primary DIP nameserver on vodip01 has stopped responding while the Secondary DNS is not healthy either. - Please look at this *now*.");
			$shouldExit = 1;
		} else {
			#Reset the error counter2 if this time everything went fine.
	               if ($errorCounter2 > 0 ) {
        	               $errorCounter2 = 0;
                	}
		}
	}
      #DNS1 replied correctly
      } else {
               #Reset the error counter1 if this time everything went fine.
               if ($errorCounter1 > 0 ) {
                       $errorCounter1 = 0;
                }
		if ($ns2Count == -1){
        		$errorCounter2 = ($errorCounter2 + 1);
			logMessage("DIP DNS 2 Warning no. $errorCounter2.");
        		if ($errorCounter2 == 3) {
				$errorCounter2 = 0;
				logMessage("DIP DNS 2 Error : The Secondary DIP nameserver on vodip02 failed 3 times to correct probing.");
				sendMail("DIP DNS 2 Error", "The Secondary DIP nameserver on vodip02 has stopped responding - restarting, please look at this.");
	                	my @args = ("/usr/sbin/logrotate /home/DIP/logRotateConfigEmergency");
        	        	system @args;
				kill 9, $childID;
				$shouldExit = 1;
			}
		} else {
		 	if ($ns2Count > 2){
				logMessage("DIP DNS 2 Warning : The Secondary DIP nameserver on vodip02 has items in whilst the primary is active - restarting.");
				sendMail("DIP DNS 2 Warning", "The Secondary DIP nameserver on vodip02 has items in whilst the primary is active - restarting");
                        	my @args = ("/usr/sbin/logrotate /home/DIP/logRotateConfigEmergency");
                        	system @args;
				kill 9, $childID;
				$shouldExit = 1;
			}
		}
      }
    } # loop until should exit
  }   #parent process
}     #loop for infinity

# param 0 - the script name that should be run
# note that the script should write the number of items in the namespace to the file nsCount.txt
# returns the number of items or -1 if failed
sub getNSCount{
  	#delete previous count file
      my $countFileName = "nsCount.txt";
      unlink($countFileName);

      my $scriptToRun = "/home/DIP/$_[0]";
      logMessage("About to run  $scriptToRun");
      #run publication count program - this program writes an output containing the count to nsCount.txt
      my @args = ($scriptToRun);
      system @args;

      #get result from file
      if (open(INFILE, $countFileName)){
      	my @lines = <INFILE>;
      	close(INFILE);
	 if ($lines[0] > 0){
		$lines[0];
      	} else {
		-1;
	}
      } else{
      		-1;
      }
}


# param 0 the message to log
sub logMessage
{
	(my $sec, my $min, my $hr, my $dom, my $mon, my $yearOffSet, my $dow, my $doy, my $dls) = localtime();
	$yearOffSet = $yearOffSet + 1900;
	#mon has range 0 - 11
	$mon = $mon + 1;
	print "$yearOffSet-$mon-$dom $hr.$min.$sec --- $_[0]\n";
}

# param 0 is the subject line
#param 1 is the message body.
sub sendMail
{
	logMessage("Mailing message - $_[1]");
        open(MAIL,"|/usr/lib/sendmail -f \"itco-dip-admins\@cern.ch\" -t");
        print MAIL "To: itco-dip-admins\@cern.ch\n";
        print MAIL "Subject: $_[0]\n";
        print MAIL "$_[1]\n";
        close (MAIL);
}
