/* Generated by Together */

/*
When starting a new window, do not allow new selections has long as the previous SubscView is not connecter or unsubscribed.
Allow again selection.
*/

package cern.dip.Browser;

import javax.swing.JFrame;

import java.awt.Font;
import java.awt.Frame;
import java.awt.event.WindowEvent;
import cern.dip.*;
import javax.swing.table.*;
import javax.swing.JTable;
import javax.swing.RowSorter;
import javax.swing.SortOrder;

import java.text.SimpleDateFormat;
import java.util.Vector;
import java.util.List;
import java.util.ArrayList;
import java.util.HashMap;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.Timer;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.BufferedWriter;

import java.io.File;
import java.io.FileWriter;

import javax.swing.WindowConstants;


class SubscriptionTableModel extends AbstractTableModel {
    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	class Field {
        public String[] values = new String[3];
    }


    public SubscriptionTableModel() { }

    String[] columnNames = new String[] { "Name", "Type", "Value" };

    Vector fieldValues = new Vector();
    HashMap fieldMap = new HashMap();

    public String getColumnName(int col) {
        return columnNames[col];
    }

    public int getRowCount() { return fieldValues.size(); }

    public int getColumnCount() { return columnNames.length; }

    public Object getValueAt(int row, int col) {
        return ((Field)fieldValues.elementAt(row)).values[col];
    }

    public boolean isCellEditable(int row, int col) { return false; }

    public void setFieldValue(String fieldName, String value) {
        int index = ((Integer)fieldMap.get(fieldName)).intValue();
        ((Field)fieldValues.elementAt(index)).values[2] = value.toString();
        this.fireTableCellUpdated(index, 2);
    }

    public void addField(String name, String type) {
        Field f = new Field();
        f.values[0] = name;
        f.values[1] = type;

        int index = fieldValues.size();
        fieldValues.add(f);
        fieldMap.put(name, new Integer(index));
        this.fireTableRowsInserted(index, index);
    }
}

public class DipSubscriptionView extends JFrame implements DipSubscriptionListener, Runnable, ActionListener  {
    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private DipFactory dipFactory = null;
    private DipSubscription subscription = null;
    private SubscriptionTableModel subscriptionTableData = new SubscriptionTableModel();
    private boolean fieldsSetUp = false;
    private JTable jTable1 = new JTable();
    private JScrollPane scrollPane = new JScrollPane(jTable1);
    private JTextField qualityReasonField = new JTextField();
    private JTextField connectedInfoField = new JTextField();
	private String pubName;
	private boolean connectionOk = false;
	private Timer theTimer = null;
	private boolean willingToClose = false;
	private boolean connectionClosed = false;
	private JPanel infoPanel = new JPanel();
	private DipMainFrame mainFrame;
    private JButton getServerInfoButton = new JButton("Get Server Info");
    private DipServerInfoView serverInfoView = null;
	private JCheckBox logEnabled = new JCheckBox("Click here to enable log. Logging is disabled.");
	private BufferedWriter logFileWriter;
	private File logFile;
	private String logPart = new String("_1");
	private boolean isHeaderWritten = false;
	private String fileName;
	private boolean logStarted = false;
	private Thread destroyThread = null;
	private DipFactoryDestroyThread theDipFactoryDestroyThread = null;

	private class DipFactoryDestroyThread implements Runnable{

    public void run() {
        try {
			//System.out.println("About to kill a subscription " + pubName);
					if (dipFactory == null || subscription == null) {
							//System.out.println("W: dipFactory = null or subscription == null.");
						} else {
							dipFactory.destroyDipSubscription(subscription);
							DipMainFrame.setSelectionAllowed(true);
							//System.out.println("Time elapsed, killed " + pubName);
						}
	        } catch (DipException de) {
            de.printStackTrace();
	        }
	    }
	}

    /** Creates new form JFrame */
    public DipSubscriptionView(DipFactory df, String pubName, DipMainFrame dmf) {
		dipFactory = df;
        this.pubName = pubName;
        mainFrame = dmf;
    }
    
    public void closeFrame(){
    	exitForm(null);
    }
    
    /** This method is called from within the constructor to initialize the form. */
    public void run() {
        this.setTitle("Subscription to " + pubName);

		setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
        addWindowListener(
            new java.awt.event.WindowAdapter() {
                public void windowClosing(java.awt.event.WindowEvent evt) {
                	if(serverInfoView != null){
                		serverInfoView.dispose();
                	}
                	exitForm(evt);
                }
            });
        infoPanel.setLayout(new java.awt.BorderLayout());
        
        infoPanel.add(qualityReasonField, java.awt.BorderLayout.SOUTH);

        infoPanel.add(getServerInfoButton, java.awt.BorderLayout.EAST);
        infoPanel.add(logEnabled, java.awt.BorderLayout.CENTER);
        
        logEnabled.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
              synchronized(logEnabled){
            	try{
            		if(logEnabled.isSelected()){
            			fileName = new String(pubName);
            			for(int i = 0;i < mainFrame.getPathSeparators().length();i++){
            				fileName = fileName.replace(mainFrame.getPathSeparators().charAt(i),'_');	
            			}
            			logFile = new File(System.getProperty("user.home") + "/DipBrowserLogs/" + fileName + logPart);
            			if(!logStarted){
            				File file = new File(System.getProperty("user.home") + "/DipBrowserLogs");
            				file.mkdir();
            				file = new File(System.getProperty("user.home") + "/DipBrowserLogs/" + fileName + "_1");
            				if(file.exists()){
            					file.delete();
            				}
            				file = new File(System.getProperty("user.home") + "/DipBrowserLogs/" + fileName + "_2");
            				if(file.exists()){
            					file.delete();
            				} 
            				logStarted = true;
            				logFileWriter = new BufferedWriter(new FileWriter(logFile, false));
            				subscription.requestUpdate();
            			}else{
            				logFileWriter = new BufferedWriter(new FileWriter(logFile, true));
            			}
            			logEnabled.setText("Click here to disable log. Logging is enabled.");
            			logEnabled.setFont(new Font(logEnabled.getFont().getFamily(),Font.BOLD,logEnabled.getFont().getSize()));
            			isHeaderWritten = false;
            		}else{
            			logFileWriter.close();
            			isHeaderWritten = false;
            			logEnabled.setText("Click here to enable log. Logging is disabled.");
            			logEnabled.setFont(new Font(logEnabled.getFont().getFamily(),Font.PLAIN,logEnabled.getFont().getSize()));
            		}
        		}catch (Exception e){
        			
        				logEnabled.setSelected(false);
        			
        			try{
        				logFileWriter.close();
        			}catch (Exception ex){
        				
        			}
        			JOptionPane.showMessageDialog(DipSubscriptionView.this, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
                    System.err.println("Error: " + e.getMessage());
                }
            }
          }
        });
        
        getServerInfoButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	if(serverInfoView == null){
            		new Thread(serverInfoView = new DipServerInfoView(pubName, mainFrame.getDNS())).start();
            	}else{
            		if (serverInfoView.isVisible()){
            			serverInfoView.setState(Frame.NORMAL);	
            		}else{
            			serverInfoView.setVisible(true);
            		}
            		serverInfoView.updateInfo();
            	}
            }
        });
        
        getServerInfoButton.setEnabled(false);
        synchronized(logEnabled){
        	logEnabled.setEnabled(false);
        }
        getContentPane().add(infoPanel, java.awt.BorderLayout.SOUTH);
        getContentPane().add(connectedInfoField, java.awt.BorderLayout.NORTH);
        
        getContentPane().add(scrollPane, java.awt.BorderLayout.CENTER);
		qualityReasonField.setText("Trying to get connection...");
        qualityReasonField.setEditable(false);
        setSize(new java.awt.Dimension(500, 300));
        setResizable(true);
        connectedInfoField.setText("Unreacheable");
        connectedInfoField.setEditable(false);
        String separator = System.getProperty("file.separator");
//        String separator = new String();
//        if(System.getProperty("os.name").toLowerCase().startsWith("windows")){
//        	separator = "\\";
//        }else{
//        	separator = "/";
//        }
        logEnabled.setToolTipText("Logfile path is " + System.getProperty("user.home") + separator + "DipBrowserLogs" + separator);
        logEnabled.setFont(new Font(logEnabled.getFont().getFamily(),Font.PLAIN,logEnabled.getFont().getSize()));
        pack();
        this.setVisible(true);
        //Now starting the timer, if after 30 seconds the status isn`t set to connected, start the unsubscription.
		theTimer = new Timer(30000, this);
		theTimer.setRepeats(false);
		theTimer.start();
        try {
			DipMainFrame.setSelectionAllowed(false);
            subscription = dipFactory.createDipSubscription(pubName, this);
        } catch (DipException de) {
            de.printStackTrace();
        }
        
    }

    public void actionPerformed(ActionEvent e) {
			if (null != subscription && connectionOk == false)
				{
					//System.out.println("Time elapsed, about to kill a subscription to " + pubName);
					qualityReasonField.setText("Unreacheable, freeing subscription.");
					if (dipFactory == null || subscription == null) {
							//System.out.println("W: dipFactory = null or subscription == null for " + pubName);
						} else {
							theDipFactoryDestroyThread = new DipFactoryDestroyThread();
							destroyThread = new Thread(theDipFactoryDestroyThread);
							destroyThread.start();
							qualityReasonField.setText("Disconnected.");
							connectionClosed = true;
							if (willingToClose == true)
							this.setVisible(false);
						}
				} else {
					//System.out.println("Subscription is fine for " + pubName);
				}
		}

    /** Exit the Application */
    private void exitForm(WindowEvent evt) {
		//System.out.println("Will close the JFrame of " + pubName + " NOW!");
		willingToClose = true;
		if (connectionOk == false && connectionClosed == false) {
					qualityReasonField.setText("Please wait for the running subscription timeout to expire...");
		} else {
				if (connectionClosed == false) {
					this.setVisible(false);
					theDipFactoryDestroyThread = new DipFactoryDestroyThread();
					destroyThread = new Thread(theDipFactoryDestroyThread);
					destroyThread.start();
					connectionClosed = true;
					//System.out.println("Unsubscribtion done for " + pubName);
			} else {
				//Communication is already closed.
				this.setVisible(false);
			}
		}
    }

    /** Make a string describing the type of this field. Arrays have the format <type>[<size>] */
    private String makeFieldTypeAsString(String fieldName, DipData message) throws BadParameter,TypeMismatch {
        String typeString;
        int type = message.getValueType(fieldName);
        switch (type) {
            case DipData.TYPE_BOOLEAN: {
                    typeString = "bool";
                    break;
                }
            case DipData.TYPE_BOOLEAN_ARRAY: {
                    boolean[] values = message.extractBooleanArray(fieldName);
                    typeString = "bool[" + values.length + "]";
                    break;
                }
            case DipData.TYPE_BYTE: {
                    typeString = "byte";
                    break;
                }
            case DipData.TYPE_BYTE_ARRAY: {
                    byte[] values = message.extractByteArray(fieldName);
                    typeString = "byte[" + values.length + "]";
                    break;
                }
            case DipData.TYPE_SHORT: {
                    typeString = "short";
                    break;
                }
            case DipData.TYPE_SHORT_ARRAY: {
                    short[] values = message.extractShortArray(fieldName);
                    typeString = "short[" + values.length + "]";
                    break;
                }
            case DipData.TYPE_INT: {
                    typeString = new Integer(message.extractInt(fieldName)).toString();
                    typeString = "int";
                    break;
                }
            case DipData.TYPE_INT_ARRAY: {
                    int[] values = message.extractIntArray(fieldName);
                    typeString = "int[" + values.length + "]";
                    break;
                }
            case DipData.TYPE_LONG: {
                    typeString = "long";
                    break;
                }
            case DipData.TYPE_LONG_ARRAY: {
                    long[] values = message.extractLongArray(fieldName);
                    typeString = "long[" + values.length + "]";
                    break;
                }
            case DipData.TYPE_FLOAT: {
                    typeString = "float";
                    break;
                }
            case DipData.TYPE_FLOAT_ARRAY: {
                    float[] values = message.extractFloatArray(fieldName);
                    typeString = "float[" + values.length + "]";
                    break;
                }
            case DipData.TYPE_DOUBLE: {
                    typeString = "double";
                    break;
                }
            case DipData.TYPE_DOUBLE_ARRAY: {
                    double[] values = message.extractDoubleArray(fieldName);
                    typeString = "double[" + values.length + "]";
                    break;
                }
            case DipData.TYPE_STRING: {
                    typeString = "string";
                    break;
                }
            case DipData.TYPE_STRING_ARRAY: {
                    String[] values = message.extractStringArray(fieldName);
                    typeString = "string[" + values.length + "]";
                    break;
                }
            default: {
                    typeString = "Unknown type";
                }
        }
        return typeString;
    }

    /**
     *Return the field value as a string, arrays are returned as a string with the following format
     * <value>, <value>, .....
     * */
    private String getFieldValueAsString(String fieldName, DipData message) throws BadParameter, TypeMismatch {
        String value = null;
        int type = message.getValueType(fieldName);
        switch (type) {
            case DipData.TYPE_BOOLEAN: {
                    value = new Boolean(message.extractBoolean(fieldName)).toString();
                    break;
                }
            case DipData.TYPE_BOOLEAN_ARRAY: {
                    boolean[] values = message.extractBooleanArray(fieldName);
                    String str = "";
                    for (int j = 0; j < Math.min(values.length, 100); j++) {
                        str = str + Boolean.toString(values[j]) + ",";
                    }
                    value = str;
                    break;
                }
            case DipData.TYPE_BYTE: {
                    value = new Byte(message.extractByte(fieldName)).toString();
                    break;
                }
            case DipData.TYPE_BYTE_ARRAY: {
                    byte[] values = message.extractByteArray(fieldName);
                    String str = "";
                    for (int j = 0; j < Math.min(values.length, 100); j++) {
                        str = str + Byte.toString(values[j]) + ",";
                    }
                    value = str;
                    break;
                }
            case DipData.TYPE_SHORT: {
                    value = new Short(message.extractShort(fieldName)).toString();
                    break;
                }
            case DipData.TYPE_SHORT_ARRAY: {
                    short[] values = message.extractShortArray(fieldName);
                    String str = "";
                    for (int j = 0; j < Math.min(values.length, 100); j++) {
                        str = str + Short.toString(values[j]) + ",";
                    }
                    value = str;
                    break;
                }
            case DipData.TYPE_INT: {
                    value = new Integer(message.extractInt(fieldName)).toString();
                    break;
                }
            case DipData.TYPE_INT_ARRAY: {
                    int[] values = message.extractIntArray(fieldName);
                    String str = "";
                    for (int j = 0; j < Math.min(values.length, 100); j++) {
                        str = str + Integer.toString(values[j]) + ",";
                    }
                    value = str;
                    break;
                }
            case DipData.TYPE_LONG: {
                    value = new Long(message.extractLong(fieldName)).toString();
                    break;
                }
            case DipData.TYPE_LONG_ARRAY: {
                    long[] values = message.extractLongArray(fieldName);
                    String str = "";
                    for (int j = 0; j < Math.min(values.length, 100); j++) {
                        str = str + Long.toString(values[j]) + ",";
                    }
                    value = str;
                    break;
                }
            case DipData.TYPE_FLOAT: {
						float v = message.extractFloat(fieldName);
	                    value = new Float(v).toString();
                    break;
                }
            case DipData.TYPE_FLOAT_ARRAY: {
                    float[] values = message.extractFloatArray(fieldName);
                    String str = "";
                    for (int j = 0; j < Math.min(values.length, 100); j++) {
                        str = str + Float.toString(values[j]) + ",";
                    }
                    value = str;
                    break;
                }
            case DipData.TYPE_DOUBLE: {
                    value = new Double(message.extractDouble(fieldName)).toString();
                    break;
                }
            case DipData.TYPE_DOUBLE_ARRAY: {
                    double[] values = message.extractDoubleArray(fieldName);
                    String str = "";
                    for (int j = 0; j < Math.min(values.length, 100); j++) {
                        str = str + Double.toString(values[j]) + ",";
                    }
                    value = str;
                    break;
                }
            case DipData.TYPE_STRING: {
                    value = message.extractString(fieldName);
                    break;
                }
            case DipData.TYPE_STRING_ARRAY: {
                    String[] values = message.extractStringArray(fieldName);
                    String str = "";
                    for (int j = 0; j < Math.min(values.length, 100); j++) {
                        str = str + values[j] + ",";
                    }
                    value = str;
                    break;
                }
			default: value = "?????";
        }
        return value;
    }

    public void handleMessage(DipSubscription subscription, DipData message) {
    	DipMainFrame.setSelectionAllowed(true);
    	connectionOk = true;
    	long ms = message.extractDipTime().getAsMillis();
    	java.util.Date date = new java.util.Date(ms);
		SimpleDateFormat df = new java.text.SimpleDateFormat("yyyy.MM.dd HH:mm:ss.SSS z");
		String time = df.format(date);
		String qualityMessage = time + "("+ms+") ~ Quality = ";
        switch (DipQualityEnum.valueOf(message.extractDataQuality())) {
            case BAD:
                qualityMessage = qualityMessage + "Bad"; 
                break;
            case GOOD:
                qualityMessage = qualityMessage + "Good";
                break;
            case UNCERTAIN:
                qualityMessage = qualityMessage + "Uncertain";
                break;
            case UNINITIALIZED:
                qualityMessage = qualityMessage + "Uninitialized";
                break;
            default:
                qualityMessage = qualityMessage + "UNKNOWN QUALITY";
                break;
        }
        qualityMessage = qualityMessage + " : " + message.extractQualityString();
       	qualityReasonField.setText(qualityMessage);


        if (DipQualityEnum.valueOf(message.extractDataQuality()) == DipQualityEnum.UNINITIALIZED) {
            return;
        }

        String[] fields = message.getTags();
         if (fieldsSetUp == false){
			try {
        	    for (int i = 0; i < fields.length; i++){
					String typeStr = makeFieldTypeAsString(fields[i], message);
                    subscriptionTableData.addField(fields[i], typeStr);
        		}
			 }catch (DipException de) { }
			fieldsSetUp = true;
            jTable1.setModel(this.subscriptionTableData);
            jTable1.setAutoCreateRowSorter(true);
            jTable1.getColumnModel().getColumn(0).setPreferredWidth(100);
            jTable1.getColumnModel().getColumn(1).setMaxWidth(80);
            jTable1.getColumnModel().getColumn(2).setPreferredWidth(120);
            
            // Create a default row sorter
            TableRowSorter<TableModel> sorter = new TableRowSorter<>(jTable1.getModel());
            jTable1.setRowSorter(sorter);
            List<RowSorter.SortKey> sortKeys = new ArrayList<>();
            sortKeys.add(new RowSorter.SortKey(0, SortOrder.ASCENDING));
            sorter.setSortKeys(sortKeys);
            sorter.sort();
	    
            pack();
     	}
        synchronized(logEnabled){
        if(logEnabled.isSelected() && !isHeaderWritten){
        	try {
        		logFileWriter.write("Publication Info");
        		for (int i = 0; i < fields.length; i++) {
   	            	logFileWriter.write("; Field(\"" + fields[i] + "\")");
        		}
        		logFileWriter.write("\r\n");
        		logFileWriter.flush();
        		isHeaderWritten = true;
        	}catch (Exception e){//Catch exception if any
    			logEnabled.setSelected(false);
    			try{
    				logFileWriter.close();
    			}catch (Exception ex){
    				
    			}
    			isHeaderWritten = false;
    			logEnabled.setText("Click here to enable log. Logging is disabled.");
    			logEnabled.setFont(new Font(logEnabled.getFont().getFamily(),Font.PLAIN,logEnabled.getFont().getSize()));
    			JOptionPane.showMessageDialog(DipSubscriptionView.this, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
                System.err.println("Error: " + e.getMessage());
            }
        }
        try {
        	if(logEnabled.isSelected()){
        		logFileWriter.write(qualityMessage.replace(';',','));
        	}
        	for (int i = 0; i < fields.length; i++) {
                String valueAsString = getFieldValueAsString(fields[i], message);
	            subscriptionTableData.setFieldValue(fields[i], valueAsString);
	            if(logEnabled.isSelected()){
	            	logFileWriter.write("; " + valueAsString);	
	            }
        	}
        	if(logEnabled.isSelected()){
        		logFileWriter.write("\r\n");
        		if(logFile.length() > 1048576){
        			logFileWriter.close();
        			if(logPart.equals("_1")){
        				logPart = "_2";
        			}else{
        				logPart = "_1";
        			}
        			logFile = new File("log/" + fileName + logPart);
//        			logFileWriter = new BufferedWriter(new FileWriter(logFile, false), 0);
        			logFileWriter = new BufferedWriter(new FileWriter(logFile, false));
        		}else{
        			logFileWriter.flush();
        		}
        	}
        } catch (Exception e) {
        	if(e instanceof DipException){
        		e.printStackTrace();
        	}else{
    			logEnabled.setSelected(false);
    			isHeaderWritten = false;
    			logEnabled.setText("Click here to enable log. Logging is disabled.");
    			logEnabled.setFont(new Font(logEnabled.getFont().getFamily(),Font.PLAIN,logEnabled.getFont().getSize()));
    			JOptionPane.showMessageDialog(DipSubscriptionView.this, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        		System.err.println("Error: " + e.getMessage());
        	}
        }}
    }

    public void disconnected(DipSubscription subscription, String reason) {
//    	infoPanel.setVisible(false);
    	connectionOk = false;
        connectedInfoField.setBackground(java.awt.Color.red);
        connectedInfoField.setText("Disconnected");

        getServerInfoButton.setEnabled(false);
        synchronized(logEnabled){
        	logEnabled.setEnabled(false);
        }
        if(serverInfoView != null){
        	if(serverInfoView.isVisible()){
        		serverInfoView.setNotConnected();
        	}
        }
        //System.out.println(pubName + " Disconnected");
    }

    public void connected(DipSubscription subscription) {
		DipMainFrame.setSelectionAllowed(true);
		connectionOk = true;
        connectedInfoField.setBackground(java.awt.Color.green);
        connectedInfoField.setText("Connected");

        getServerInfoButton.setEnabled(true);
        synchronized(logEnabled){
        	logEnabled.setEnabled(true);
        }
        if(serverInfoView != null){
        	if(serverInfoView.isVisible()){
        		serverInfoView.updateInfo();
        	}
        }
        //System.out.println(pubName + " Connected");
    }

    public void handleException(DipSubscription subscription, Exception ex) {
        System.out.println("Error " + ex.getMessage());
    }

	public boolean isConnectionOk() {
		return connectionOk;
	}
}
