#ifndef GET_PARAMETER_HPP

#define GET_PARAMETER_HPP

#include <iostream>
#include <cstdlib>
#include <string>

#ifdef USE_INI
#include "IniReader.h"
#endif


#ifdef USE_INI
#define GETINTPARAMETER(a,b)   getIntParameter(a,b,reader);
#define GETSTRINGPARAMETER(a)   getStringParameter(a,reader);
#endif

#ifndef USE_INI
#define GETINTPARAMETER(a,b)   getIntParameter(a,b);
#define GETSTRINGPARAMETER(a)   getStringParameter(a);
#endif


#ifdef USE_INI
void getIntParameter(int& parameter, const char* name, INIReader reader) {
	parameter = reader.GetInteger("dimBridge",name, parameter);

	//cout << "Reading " << name <<  " " << parameter << endl;

}

const char* getStringParameter(const char* name,  INIReader reader) {
	
	string res = reader.Get("dimBridge", name, "");
	if (res == "") return NULL;

	//cout << "Reading " << name << " " <<  res << endl;
	char* result = new char[res.length()+1];
    strcpy(result,res.c_str());
    return result;
	
}
#endif 

#ifndef USE_INI
void getIntParameter(int& parameter, const char* name) {
	const char* val = getenv(name);
	if (val) {
			parameter = atoi(val);
	}	

}

char* getStringParameter(const char* name) {
	return getenv(name);
	
}
#endif

#endif /* GET_PARAMETER_HPP */