#include "Dip.h"
#include <string>
#include <iostream>
#include <sstream>
#include <vector>
#include "DIPVersion.h"
#include <unistd.h>

#define _GLIBCXX_USE_CXX11_ABI 0

using namespace std;

/**
* Simple demo server that publishes DIP data.
* */

class ErrHandler:public DipPublicationErrorHandler{
	void handleException(DipPublication* publication, DipException& ex){
		printf("DIP Error upon publication : %s", ex.what());
	}
};

int main(const int argc, const char** argv) {
   string pubName = "dip/test/api/structure/change";
   
   cout<<" Using "<<DipVersion::getDipVersion() <<endl;

	DipPublication *pub;
	DipData *pubData;
	DipTimestamp aTimeStamp;

	//Creating the server.
	string serverName = "dip-test-api-structure-change";
	DipFactory *dip = Dip::create(serverName.c_str());
	ErrHandler errorHandler;
    pub =dip->createDipPublication(pubName.c_str(), &errorHandler);
	
    DipBool boolValue=true;
	DipInt intValue = 1;

	for(int cycles =0 ; cycles < 3 ; cycles++){
        ////////////////////////
        // Do five updates with two fields.....
        unsigned int iterations = 5;
        while(iterations--){
            try{
               pubData= dip->createDipData();
               pubData->insert(boolValue);
               DipTimestamp time;
                
               cout<< "Posting BOOLEAN data to pub "<< pub->getTopicName() << endl;
               pub->send(pubData, time);
    
               sleep(1);
            } catch (DipException e){
                cout << "Failed to send data" << endl;
            }
        }
        
        // .... Recreate the publication
        dip->destroyDipPublication(pub);
        pub = dip->createDipPublication(pubName.c_str(), &errorHandler);
        
        // //////////////////////
        // .... Do five more updates with three fields.....
        iterations = 5;
        while(iterations--){
            try{
                pubData = dip->createDipData();
	            pubData->insert(intValue);
                DipTimestamp time;
                
                cout<< "Posting INT data to pub "<< pub->getTopicName() << endl;
                pub->send(pubData, time);
    
                intValue++;
    
                sleep(1);
            } catch (DipException e){
                printf("Failed to send data\n");
            }
        }
    }

	cout<<"DIP server lifetime has expired, leaving... "<<endl;
    dip->destroyDipPublication(pub);
	
    cout<<"Done."<<endl;
	return 0;
}
