#include <gtest/gtest.h>

#ifdef WIN32
#include <windows.h>
#else
#include <unistd.h>
#endif

#include <stdio.h>
#include <string>
#include <iostream>
#include <sstream>
#include <pthread.h>
#include "gtest_main.hpp"

#include "Dip.h"
#include "DipSubscription.h"
#include "DipBrowser.h"

using namespace std;


TEST(integrationTests, browserLoopTest) {
   DipFactory *dip;


   unsigned int numberOfPubs;

   dip = Dip::create("browserLoopTest");
   dip->setDNSNode("dipns1,dipns2");

   DipBrowser* browser = dip->createDipBrowser();
   
   for (int i = 0 ; i < 5 ; i++){
     cout << "Counting now..." <<endl;
     const char** pubs = browser->getPublications("dip/ATLAS/*", numberOfPubs);
   
     cout << "Got "<< numberOfPubs << " publications "<<endl;
     sleep(2);
   }
   
   cout << "Now shutting down."<<endl;

   Dip::shutdown();

   exit(0);
}

