import cern.dip.*

dipFactory = Dip.create("it-structure-changes-publisher");

dipFactory.setDNSNode("dipnsdev");

public class LocalErrorHandler implements DipPublicationErrorHandler{
	public void handleException(DipPublication publication, DipException ex){
			println "Error :"+publication.getTopicName()+" "+ex.getMessage()	
	}
}

	
publications = []

numberOfPublications = System.getenv()["NUMBER_OF_PUBLICATIONS"] ?: 5

firstStructure = dipFactory.createDipData()
firstStructure.insert("doubleVal", new Double(0.78))
firstStructure.insert("stringVal", (String[])["some value","and another"])
firstStructure.insert("intVal", new Integer(14))

secondStructure = dipFactory.createDipData()
secondStructure.insert("doubleVal", new Double(0.78))
secondStructure.insert("stringVal", (String[])["some value","and another"])
secondStructure.insert("intVal", new Integer(14))
secondStructure.insert("boolVal", new Boolean(true))


List create(df, pubs, nbOfPubs){
    pubs.clear()
	for(int i = 0; i < nbOfPubs ; i++){
	  pubs[i] = df.createDipPublication("dip/it/StructureChangesPublisher/pub"+i,new LocalErrorHandler())
	}
	return pubs
}

void send(pubs, dd){
   pubs.each() { 
    try{
    it.send(dd, new DipTimestamp())
    }catch(DipException e){
      println e.message
    }
   }
}

void destroy(df, pubs){
   pubs.each() { df.destroyDipPublication(it) }
   pubs.clear()
}

addShutdownHook {
    destroy(dipFactory, publications)
}

create(dipFactory, publications, numberOfPublications)

println "Now publishing alternate structure"


while(true){
  send(publications, secondStructure)
  Thread.sleep(500L)
}