import cern.dip.*
import static cern.dip.DipQualityEnum.*

dipFactory = Dip.create("it-structure-changes-publisher");

dipFactory.setDNSNode("dipnsdev");

public class LocalErrorHandler implements DipPublicationErrorHandler{
	public void handleException(DipPublication publication, DipException ex){
			println "Error :"+publication.getTopicName()+" "+ex.getMessage()	
	}
}

	
publications = []

numberOfPublications = System.getenv()["NUMBER_OF_PUBLICATIONS"] ?: 5

firstStructure = dipFactory.createDipData()
firstStructure.insert("doubleVal", new Double(0.78))
firstStructure.insert("stringVal", (String[])["some value","and another"])
firstStructure.insert("intVal", new Integer(14))



List create(df, pubs, nbOfPubs){
    pubs.clear()
	for(int i = 0; i < nbOfPubs ; i++){
	  pubs[i] = df.createDipPublication("dip/it/disconnect/pub"+i,new LocalErrorHandler())
	}
	return pubs
}

void send(pubs, dd){
   pubs.each() { 
    try{
    it.send(dd, new DipTimestamp())
    }catch(DipException e){
      println e.message
    }
   }
}

void send(pubs, dd, qual, qualReason){
   pubs.each() { 
    try{
    it.send(dd, new DipTimestamp(),qual,qualReason )
    }catch(DipException e){
      println e.message
    }
   }
}

void destroy(df, pubs){
   pubs.each() { df.destroyDipPublication(it) }
   pubs.clear()
}

addShutdownHook {
    destroy(dipFactory, publications)
}

create(dipFactory, publications, numberOfPublications)

while(true){
  println("Publishing good quality....")
//  send(publications, firstStructure, GOOD.intValue(), "")
  send(publications, firstStructure)
  Thread.sleep(1000L)
  println("Destroying....")
  destroy(dipFactory, publications)
  Thread.sleep(2000L)
  println("Recreating....")
  create(dipFactory, publications, numberOfPublications)
//  println("Publishing bad quality....")
//  send(publications, firstStructure, BAD.intValue(), "switched to BAD")
  Thread.sleep(1000L)
}