//#include <gtest/gtest.h>
//
//#ifdef WIN32
//#include <windows.h>
//#else
//#include <unistd.h>
//#endif
//
//#include <stdio.h>
//#include <string>
//#include <iostream>
//#include <sstream>
//#include <pthread.h>
//#include "gtest_main.hpp"
//
//#include "Dip.h"
//#include "DipSubscription.h"
//#include "DipException.h"
//
//using namespace std;
//
//
//string    someString = "test";
//DipBool	  someBool   = true;
//DipByte	  someByte   = 1;
//DipShort  someShort  = 1;
//DipInt	  someInt    = 1;
//DipLong	  someLong   = 1073741824l;
//DipFloat  someFloat  = 1.0f;
//DipDouble someDouble = 1.0f;
//
//int sizefields = 10;
//
//string*    someStringArray = new string[sizefields];
//DipBool*   someBoolArray   = new DipBool[sizefields];
//DipByte*   someByteArray   = new DipByte[sizefields];
//DipShort*  someShortArray  = new DipShort[sizefields];
//DipInt*    someIntArray    = new DipInt[sizefields];
//DipLong*   someLongArray   = new DipLong[sizefields];
//DipFloat*  someFloatArray  = new DipFloat[sizefields];
//DipDouble* someDoubleArray = new DipDouble[sizefields];
//
//void initArrays(){
//	for (int i = 0 ;i < sizefields ; i++) {
//		someStringArray[i] = '\0';
//		someBoolArray[i] = true;
//		someByteArray[i] = 0;
//		someShortArray[i] = 0;
//		someIntArray[i] = 0;
//		someLongArray[i] = 0;
//		someFloatArray[i] = 0.0f;
//		someDoubleArray[i] = 0.0f;
//    }
//}
//
//
//
//class LocalErrHandler:public DipPublicationErrorHandler{
//  public:
//	void handleException(DipPublication* publication, DipException& ex){
//		 cout << "DIP publication error:" << ex.what()<<endl;
//	}
//};
//
//
//
//TEST(integrationTests, structureChangeServerTest) {
//   DipPublication **pub;
//   DipFactory *dip;
//   LocalErrHandler errHandler;
//   dip = Dip::create("StructureChangesSubscriber");
//   initArrays();
//
//
//
//   int numberOfPubs = 500;
//   pub = new DipPublication*[numberOfPubs];
//   cout << "Creating publications..."<<endl;
//   for(int i = 0 ; i < numberOfPubs ; i++){
//        ostringstream oss;
//        oss << "dip/it/StructureChangesPublisher/pub";
//        oss.fill('0');
//        oss << setw(3) << i;
//        pub[i] = dip->createDipPublication(oss.str().c_str(), &errHandler);
//   }
//   cout << "Pushing initial publications data..."<<endl;
//
//   for(int i = 0 ; i < numberOfPubs ; i++){
//   			   DipTimestamp time;
//   			   DipData* dat = dip->createDipData();
//   			   dat->insert(someString,"stringValue");
//   			   dat->insert(someDouble,"doubleValue");
//   			   dat->insert(someInt,"intValue");
//   			   dat->insert(someBool,"booleanValue");
//   			   pub[i]->send(
//   					   *dat
//   					   , time);
//   			   delete dat;
//	  }
//
//	 cout << "Sleeping"<<endl;
//	 sleep(2);
//
//   int count = 0;
//   int errors = 0;
//
//
//   cout << "Publishing invalid data..."<<endl;
//
//   while(count < 10){
//
//
//		   for(int i = 0 ; i < numberOfPubs ; i++){
//				   DipTimestamp time;
//				   DipData* dat = dip->createDipData();
//				   dat->insert(someString,"stringValue");
//				   dat->insert(someDouble,"doubleValue");
//				   dat->insert(someInt,"intValue");
//				   //dat->insert(someBool,"booleanValue");
//				   try{
//					   pub[i]->send(
//						   *dat
//						   , time);
//				   }catch(const DipException & e){
//				  		   cout<< "Error : " << e.what() << endl;
//
//				  		   errors ++;
//				  	   }
//				   delete dat;
//		   }
//
//
//	   sleep(0.2);
//	   count++;
//
//   }
//   cout <<endl<< "Destroying publications.."<<endl;
//
//   for(int i = 0 ; i < numberOfPubs ; i++){
//    	cout << "Destroying pub .."<<i;
//        dip->destroyDipPublication(pub[i]);
//        cout << "..Destroyed"<<endl;
//    }
//
//    cout << "Now shutting down."<<endl;
//    sleep(1);
//
//   Dip::shutdown();
//
//   cout<< "Completed the test with "<< errors<< " registered DIP exceptions"<<endl;
//
//   exit(0);
//
//}


