#include "DipDimPublication.h"



DipDimPublication::DipDimPublication(std::string &topicname, DipPublicationErrorHandler &theHandler):
theName(topicname),
dimServer(NULL),
handler(theHandler)
{
  dimServer = new DipDimServer(topicname, *this);
}

void DipDimPublication::send(const std::string & value,const DipTimestamp & timestamp)
{
	DipDimData data;
  	data.insert(value);
	send(data, timestamp);
}


void DipDimPublication::send(const char * value,const DipTimestamp & timestamp)
{
	if (value == NULL){
		throw DipException("DipDimPublication::send - usr passed NULL value");
	}
	DipDimData data;
  	data.insert(value);
	send(data, timestamp);
}


void DipDimPublication::send(DipBool value,const DipTimestamp & timestamp)
{
	DipDimData data;
  	data.insert(value);
	send(data, timestamp);
}
  



void DipDimPublication::send(DipByte value,const DipTimestamp & timestamp)
{
	DipDimData data;
  	data.insert(value);
	send(data, timestamp);
}
  
  
 


void DipDimPublication::send(DipShort value,const DipTimestamp & timestamp)
{
	DipDimData data;
  	data.insert(value);
	send(data, timestamp);
}



void DipDimPublication::send(DipInt value,const DipTimestamp & timestamp)
{
	DipDimData data;
  	data.insert(value);
	send(data, timestamp);
}




void DipDimPublication::send(DipLong value,const DipTimestamp & timestamp)
{
	DipDimData data;
  	data.insert(value);
	send(data, timestamp);
}



void DipDimPublication::send(DipFloat value,const DipTimestamp & timestamp)
{
	DipDimData data;
  	data.insert(value);
	send(data, timestamp);
}
 


void DipDimPublication::send(DipDouble value,const DipTimestamp & timestamp)
{
	DipDimData data;
  	data.insert(value);
	send(data, timestamp);
}


void DipDimPublication::send(const DipBool *value,int size,const DipTimestamp & timestamp)
{
	if (value == NULL){
		throw DipException("DipDimPublication::send - usr passed NULL value");
	}
	DipDimData data;
  	data.insert(value, size);
	send(data, timestamp);
}



void DipDimPublication::send(const DipByte *value,int size,const DipTimestamp & timestamp)
{
	if (value == NULL){
		throw DipException("DipDimPublication::send - usr passed NULL value");
	}
	DipDimData data;
  	data.insert(value, size);
	send(data, timestamp);
}
 


void DipDimPublication::send(const DipShort *value,int size,const DipTimestamp & timestamp)
{
	if (value == NULL){
		throw DipException("DipDimPublication::send - usr passed NULL value");
	}
	DipDimData data;
  	data.insert(value, size);
	send(data, timestamp);
}
 


void DipDimPublication::send(const DipInt *value,int size,const DipTimestamp & timestamp)
{
	if (value == NULL){
		throw DipException("DipDimPublication::send - usr passed NULL value");
	}
	DipDimData data;
  	data.insert(value, size);
	send(data, timestamp);
}



void DipDimPublication::send(const DipLong *value,int size,const DipTimestamp & timestamp)
{
	if (value == NULL){
		throw DipException("DipDimPublication::send - usr passed NULL value");
	}
	DipDimData data;
  	data.insert(value, size);
	send(data, timestamp);
}



void DipDimPublication::send(const DipFloat *value,int size,const DipTimestamp & timestamp)
 {
	if (value == NULL){
		throw DipException("DipDimPublication::send - usr passed NULL value");
	}
	DipDimData data;
  	data.insert(value, size);
	send(data, timestamp);
}



void DipDimPublication::send(const DipDouble *value,int size,const DipTimestamp & timestamp)
{
	if (value == NULL){
		throw DipException("DipDimPublication::send - usr passed NULL value");
	}
	DipDimData data;
  	data.insert(value, size);
	send(data, timestamp);
}




void DipDimPublication::send(const std::string *value,int size,const DipTimestamp & timestamp)
{
	if (value == NULL){
		throw DipException("DipDimPublication::send - usr passed NULL value");
	}
	DipDimData data;
  	data.insert(value, size);
	send(data, timestamp);
}



void DipDimPublication::send(const char **value,int size,const DipTimestamp & timestamp)
{
	if (value == NULL){
		throw DipException("DipDimPublication::send - usr passed NULL value");
	}
	DipDimData data;
  	data.insert(value, size);
	send(data, timestamp);
}



void DipDimPublication::send(const DipData &value,const DipTimestamp & timestamp)
{
//	DipDimData & dimData = (DipDimData &)value;
//	dimData.setDipTime(timestamp);
//	dimServer->send(dimData, DIP_QUALITY_GOOD, "");
	send(value, timestamp, DIP_QUALITY_GOOD, "");
}
  
void DipDimPublication::send(const DipData &value,const DipTimestamp & timestamp, DipQuality quality, const char * reason)
{
	DipDimData & dimData = (DipDimData &)value;
	dimData.setDipTime(timestamp);
	dimServer->send(dimData, quality, ((reason) ? reason : ""));
}

void DipDimPublication::setQualityBad(const char * reason)
{
	const char * r = (reason) ? reason : "";
	dimServer->resendWithNewQuality(DIP_QUALITY_BAD, r);
}
  
 
  



void DipDimPublication::setQualityUncertain(const char * reason)
{
	const char * r = (reason) ? reason : "";
	dimServer->resendWithNewQuality(DIP_QUALITY_UNCERTAIN, r);
}
