#include "DipException.h"

DipException::DipException(const std::string &msg):
std::runtime_error(msg)
{
	DERROR(("Exception %s\n", msg.c_str()));
}


DipInternalError::DipInternalError(const std::string & message):
DipException(message)
	{
	}


DipDIMInternalError::DipDIMInternalError(const std::string & message, int theErrorCode):
DipInternalError(message), errorCode(theErrorCode)
	{
	}

	
int DipDIMInternalError::getErrorCode()
	{
		return errorCode;
	}

TypeMismatch::TypeMismatch(std::string & msg):DipException(msg)
	{
	}

TypeMismatch::TypeMismatch():DipException(std::string("Type Mismatch"))
	{
	}

BadParameter::BadParameter(std::string & msg):DipException(msg) 
	{
	}

BadParameter::BadParameter():DipException(std::string("Bad Parameter"))
	{
	}
