#include "DipTypeService.h"
#include "DipTypeUtil.h"
#include <iostream>

using namespace std;

const SString DipTypeService::dipTypeServiceEnding("/DipType");

void DipTypeService::sendDipData(const SString & dipDataString){
	//DTRACE(("In DipTypeService::sendDipData\n"));
	dimDataString = DipTypeUtil::buildDimTypeServiceData(dipDataString.getString());
	setQuality(dataQuality);
	longlong timeNs = timeStamp.getAsNanos();
	setTimestamp(int(timeNs/1000000000), int(timeNs%1000000000));
	char * typeString = dimDataString.getString();
	//DINFO(("%s sending %s with quality %d\n",this->getName(), typeString, dataQuality));
	this->updateService(typeString);
	//DTRACE(("Out DipTypeService::sendDipData\n"));
}

DipTypeService::DipTypeService(const SString & dipName):
DimService(static_cast<char *>((dipName + dipTypeServiceEnding)), const_cast<char *>(DipVersion::getDipVersion().c_str())){
	
	reasonForQuality="";
	dataQuality=DIP_QUALITY_UNINITIALIZED;
	sendDipData("");
}


void DipTypeService::sendQualityIfChanged(const SString &reason){
	if (reasonForQuality != reason){
		sendDipData(reason);
		reasonForQuality = reason;
	}
}

void DipTypeService::setQualityUncertain(const SString &reason){
	// quality remains uninit
	sendQualityIfChanged(reason);
}

void DipTypeService::setQualityBad(const SString &reason){
	// quality remains uninit
	sendQualityIfChanged(reason);
}

void DipTypeService::setTypeFormat(const SString &format){
	dataQuality = DIP_QUALITY_GOOD;
	sendDipData(format);
}

void DipTypeService::resendToClient(int clientID){
	setQuality(dataQuality);
	longlong timeNs = timeStamp.getAsNanos();
	setTimestamp(int(timeNs/1000000000), int(timeNs%1000000000));
	selectiveUpdateService(static_cast<char *>(dimDataString), &clientID);
}
