#include "DIPVersion.h"

const std::string DipVersion::dipVersion = "DIP-5.7.0";

const std::string & DipVersion::getDipVersion(){
	// WARNING - Make sure DIPVersion.h getDipVersionStringLen() is updated accordingly !
	// This string should be exactly 9 Chars long (or all DIP tag names get prefix with the extra characters !?)
	// C.f. ENS-1218
// CG 13/09/2018 
// Update: Created a DIM service for publishing the Version for both Publishers and Subscribers (<name>/DIP_VERSION)
// Turned the DipVersion string dynamic size by using a "|" separator to avoid problems in the future
// In order to be backward compatible the string now has to contain a "-", example: DIP-5.6.4 
// so that the new clients can detect old or new version and at the moment the string used in the publication 
// type service gets truncated to 9 characters so that old clients still work 
// (the truncation can disappear when all clients go to v5.7 and above).

	return dipVersion;
}

/* temporary until all DIP Subscribers above v5.7 */
const std::string & DipVersion::getPublicationDipVersion(){
	static std::string tmpVersion = dipVersion;

	if(tmpVersion.size() < 8)
		tmpVersion.append(8 - tmpVersion.length(), ' ');
	tmpVersion = tmpVersion.substr(0,8) + "|";
/* Later on should be only:
	tmpVersion = dipVersion + "|";
*/
	return tmpVersion;
}

unsigned int DipVersion::getDipVersionStringLen(){
	return dipVersion.size();
}

unsigned int DipVersion::getDipVersionStringLen(const std::string & dimData){
size_t pos;
	if (dimData.substr(0,4) == "DIP-")
	{
		pos = dimData.find('|');
		if(pos != std::string::npos)
			return pos+1;
		return 0;
	}
	else
	{
		return 9;
	}
} 

