#ifndef DIPDATACLIENT
#define DIPDATACLIENT


#include "Options.h"
#include "DipData.h"
#include "dic.hxx"
#include "DipTypeClient.h"
#include "DipDataExtractor.h"


class DipDataClient:public DimStampedInfo{
private:	
	DipDataObjectListener & dataObjectListener;

	/// Used to extract data from the dim data service according to the format provided by the dim type service
	DipDataExtractor dipDataExtractor;

	std::string pubName;

public:
	DipDataClient(const std::string & dipPubName, DipDataObjectListener & datalistener);


	void infoHandler();


	void invalidateDataFormat(){
		dipDataExtractor.setDipDataFormatValidity(0);
	}

	void validateDataFormat(){
		dipDataExtractor.setDipDataFormatValidity(1);
	}

	void setDataFormat(const std::string & format){
		dipDataExtractor.defineDipDataFormat(format);
	}

	const std::string & getDataFormat(){
		return dipDataExtractor.getDipDataFormat();
	}
};

#endif

