#ifndef DipDimSubscription_h
#define DipDimSubscription_h


#include "Options.h"
#include "DipDimClient.h"
#include "DipDimFactory.h"

#include "DipLogger.h"




class DipDimSubscription: public DipSubscription
{
private:
	std::string theName;

	DipDimClient *dimClient;

public:
	DipDimSubscription(const std::string & topicName, DipSubscriptionListener & listener);
	
	
	~DipDimSubscription(){
		if (dimClient){
			delete dimClient;
			LOG4CPLUS_INFO(DipLogger::getLoggerFromTopic(LOG_DIP_SUB_PREFIX,theName.c_str()),LOG4CPLUS_TEXT("Deleted DIM client for subscription."));
//			DINFO(("Deleted Dim Client for subscription %s\n", theName.c_str()));
		}
	}



	const char * getTopicName()
	{
		return theName.c_str();
	}



	/**
	* Requests last value to be re-send. This value will be received via the normal subscription
	* listener mechanism.
	* @throws DipException if requesting update has failed
	*/
	void requestUpdate()
	{
		dimClient->doRequest();
	}
};


#endif
