// DipDimFactory.h: interface for the DipDimFactory class.
//////////////////////////////////////////////////////////////////////
#ifndef DIPSYNTAXENFORCER_H_
#define DIPSYNTAXENFORCER_H_
#include "DipException.h"

#include "DipLogger.h"

#include <string>

/*
* This class makes sure the provided names are compliant with DIP naming convention.
* If not, a warning is sent.
*/
class DipSyntaxEnforcer {

private:
	/*Authorized characters.*/
	static const std::string authorizedChars;

	/*Authorized delimiters.*/
	static const std::string authorizedDelimiters;

public:
	/*Checks whether the string passed is a fully valid DIP nam for a publication.
	* If not, it returns false and generatede warnings.
	*/
	static bool checkPublicationName(const std::string & dipPubName, const log4cplus::Logger logger);
};

#endif /*DIPSYNTAXENFORCER_H_*/
