#ifndef DIPTYPECLIENT
#define DIPTYPECLIENT

#include "Options.h"
#include "DipData.h"
#include "dic.hxx"
#include "SString.h"


class DipDataObjectListener{
public:
	virtual void dipDataReceived(const DipData & data) = 0;
};



class DipDataFormatListener{
public:
	virtual void gotDipDataFormat(const std::string & format) = 0;
};



class DisconnectListener{
public:
	virtual void disconnected(const DimStampedInfo & source) = 0;
};





class DipTypeClient:public DimStampedInfo{
private:	
	DipDataObjectListener & dataObjectListener;
	DipDataFormatListener & dataFormatListener;
	DisconnectListener & disconnectListener;

	SString dimServiceName;

public:
	DipTypeClient(const SString & dipPubName, DipDataObjectListener & datalistener, DipDataFormatListener & formatlistener, DisconnectListener & discListener);

	void infoHandler();

	static const char * noLink;
};

#endif

