#ifndef DIPTYPESERVICE
#define DIPTYPESERVICE

#include "Options.h"
#include "dis.hxx"
#include "DipQuality.h"
#include "DipTimestamp.h"
#include "SString.h"


// Used to provide the client with type information concerning the data it's subscribed to.
class DipTypeService:protected DimService{

private:
	DipQuality dataQuality;

	DipTimestamp timeStamp;

	SString dimDataString;

	SString reasonForQuality;

	void sendDipData(const SString & dipDataString);

	void sendQualityIfChanged(const SString &reason);
	 

public:
	DipTypeService(const SString & dipName);

	void setQualityUncertain(const SString &reason);
	void setQualityBad(const SString &reason);
	void setTypeFormat(const SString &format);
	void resendToClient(int clientID);

	static const SString dipTypeServiceEnding;
};

#endif
