package cern.dip.examples;

import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;

import cern.dip.Dip;
import cern.dip.DipException;
import cern.dip.DipFactory;
import cern.dip.DipPublication;
import cern.dip.DipPublicationErrorHandler;
import cern.dip.DipTimestamp;

public class ServerMain {
	
	java.util.logging.Logger m_logger = Logger.getLogger(getClass().getName());

	ArrayList<DipPublication> m_publications = new ArrayList<DipPublication>();
	public ServerMain() throws Exception{
		DipFactory df = Dip.create("examples-java-server");

		df.setDNSNode("localhost");

		DipPublicationErrorHandler dipPublicationErrorHandler = new DipPublicationErrorHandler() {

			@Override
			public void handleException(DipPublication arg0, DipException arg1) {
				m_logger.log(Level.SEVERE, "Exception while publishing "+arg0, arg1);

			}
		};
		for (int i = 1; i <= 500; i++) {
			DipPublication dp = df.createDipPublication("dip/examples/pub"+i, dipPublicationErrorHandler);
			m_publications.add(dp);
			dp.send((float)i, new DipTimestamp());
		}
		
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception{
		ServerMain main = new ServerMain();
		while(true){
			Thread.sleep(2000L);
		}
	}

}
