import cern.dip.*


public class LocalListener implements DipSubscriptionListener{
	void handleMessage(DipSubscription subscription, DipData message){
		  println("Received data from subscription "+subscription.topicName)
		}
		
		void disconnected(DipSubscription subscription, String reason){
			  println("Disconnected from subscription "+subscription.topicName+" : "+reason)
		}
		
		
		void connected(DipSubscription subscription){
			  println("Connected to subscription "+subscription.topicName)
		}
		
		void handleException(DipSubscription subscription, Exception ex){
			  println("Exception on "+subscription.getTopicName()+" "+ex)
		}
}

println "starting"

m_df = Dip.create("DIP40Subscriber");

m_df.setDNSNode("localhost");

ll = new LocalListener();

subscriptions = []
subscriptionNames = ["dip/test/BKGDREPUB"]
subscriptionNames.each(){ subName ->
   subscriptions << m_df.createDipSubscription(subName, ll)
}
println "created "+subscriptions.size()+" subscriptions"


