import cern.dip.DipTimestamp
import cern.dip.DipPublicationErrorHandler
import cern.dip.DipFactory
import cern.dip.*

m_df = Dip.create("double-publisher-dip-server2");

m_df.setDNSNode("localhost");

public class LocalErrorHandler implements DipPublicationErrorHandler{
	public void handleException(DipPublication publication, DipException ex){
			println "Error :"+publication.getTopicName()+" "+ex.getMessage()	
	}
}

ts = null

publication = m_df.createDipPublication("dip/test/API/Server0_0",new LocalErrorHandler());
Thread.sleep(500);

   for(i in 1..4){
	dd = m_df.createDipData();
	dd.insert("field_0", "Current time is "+System.currentTimeMillis());
	dd.insert("field_4", new Float((float)System.currentTimeMillis() % 60)+ 0.2f);
	dd.insert("field_5", new Boolean(true));
	dd.insert("field_6", (Boolean[]) [true, false]);

	
	ts = new DipTimestamp()
	publication.send(dd, ts);
	println("... ");
	Thread.sleep(1000);
   }

   m_df.destroyDipPublication(publication);
   Thread.sleep(500);
   publication = m_df.createDipPublication("dip/test/API/Server0_0",new LocalErrorHandler());

   long lastTimeStamp = ts.getAsMillis();
   println("Now sending the same last timestamp over and over");
 
   shouldStopPublication = false;
   
   thr = Thread.start{
	  def reader = new BufferedReader(new InputStreamReader(System.in))
	  
	  while ((!shouldStopPublication) && ((nextStr = reader.readLine()) != null)) {
		  if(nextStr == 'QUIT'){
		    shouldStopPublication = true;
		    reader.close();
		  }
	  }
	}
  
   count = 0;
   while(! shouldStopPublication){
	dd = m_df.createDipData();
	dd.insert("field_0", "Current time is "+System.currentTimeMillis());
	dd.insert("field_4", new Float((float)System.currentTimeMillis() % 60)+ 0.2f);
	dd.insert("field_5", new Boolean(count%2==0));
        dd.insert("field_6", (Boolean[]) [count%2==0,count%2!=0]);

	count ++;
	newts = null;
	
	switcher = count % 3;
	switch(switcher )
	{
	   case 0:  newts = ts; break;
	   case 1: newts = new DipTimestamp(System.currentTimeMillis() + (60*60000)); break;
	   default: newts = new DipTimestamp();
	}
	publication.send(dd, newts);
	println("... ");
	Thread.sleep(1000);
   }
   
   m_df.destroyDipPublication(publication);
