import cern.dip.DipTimestamp
import cern.dip.DipPublicationErrorHandler
import cern.dip.DipFactory
import cern.dip.*

m_df = Dip.create("disconnection-test-dip-server");

m_df.setDNSNode("localhost");

def readUntilAck(inS, grepPattern) {
  def reader = new BufferedReader(new InputStreamReader(inS))
  def finished = false
  while (!finished && ((next = reader.readLine()) != null )) {
        if(next =~ grepPattern){
          finished=true
        } else{
          println "Rejected Input :" +next
        }
  }
}

public class LocalErrorHandler implements DipPublicationErrorHandler{
	public void handleException(DipPublication publication, DipException ex){
			println "Error :"+publication.getTopicName()+" "+ex.getMessage()	
	}
}
	

publication = m_df.createDipPublication("dip/diptest/disconnectionTest/testPub1",new LocalErrorHandler());
Thread.sleep(500);

// Send five updates, ensure they are received by the client process
for(int i = 0 ; i < 5 ; i++){
	dd = m_df.createDipData();
	dd.insert("doubleVal", new Double(0.78));
	println "Sending update "+i
	publication.send(dd, new DipTimestamp(new Date().getTime()))
        println "Update "+i+" sent, waiting for ACK"
        readUntilAck(System.in, "^ACK Update "+i+"\$")
        Thread.yield()
        Thread.sleep(20)
}

println "Waiting for disconnect ACK.."

readUntilAck(System.in, "^ACK Ready for disconnect\$")

println "Now disconnecting abruptly..."

Thread.sleep(500)

System.exit(0)



