import cern.dip.DipTimestamp
import cern.dip.DipPublicationErrorHandler
import cern.dip.DipFactory
import cern.dip.*

m_df = Dip.create("disconnection-test-dip-client");

m_df.setDNSNode("localhost");


def waitForConnection(WaiterSubListener waiterListener){
	waiterListener.waiting=true
	waiterListener.waitingForConnection=true

	// Wait to be connected and ACK the connection
	println "Waiting for DIP connection..."
	while(waiterListener.waiting){
		Thread.sleep(500);
	}
	println "ACK connection"
}

class WaiterSubListener implements DipSubscriptionListener{
	public Boolean waiting = true;
	public Boolean waitingForDisconnection = false;
	public Boolean waitingForConnection = false;
	public Boolean waitingForMessage = false;
	
	void handleMessage(DipSubscription subscription, DipData message){
		if(waitingForMessage){
		  println "DIP message received !!!"
	          waiting = false;
	          waitingForMessage=false;
	        }
	}
		
	void disconnected(DipSubscription subscription, String reason){
		if(waitingForDisconnection){
		  println "DIP Publisher disconnected !!!"
	          waiting = false;
	          waitingForDisconnection=false;
	        }
	}
			
	void connected(DipSubscription subscription){
		if(waitingForConnection){
		  println "DIP Publisher (re)connected !!!"
	          waiting = false;
	          waitingForConnection=false;
	        }
	}
	
	void handleException(DipSubscription subscription, Exception ex){
	        println "DIP exception "+ex
	}
};

waiterListener = new WaiterSubListener();

	
sub = m_df.createDipSubscription("dip/diptest/disconnectionTest/testPub1",waiterListener);


waitForConnection(waiterListener);

// Wait for five updates
waiterListener.waiting=true
waiterListener.waitingForMessage=true

def countUpdates = 0
for(countUpdates= 0 ; countUpdates < 4 ; countUpdates++){
	println "Waiting for DIP update "+countUpdates+" ..."
	while(waiterListener.waiting){
	 Thread.sleep(500);
	}
	waiterListener.waiting=true
	waiterListener.waitingForMessage=true

	println "ACK Update "+countUpdates
}
waiterListener.waitingForMessage=false

// Wait for disconnection
waiterListener.waitingForDisconnection=true
waiterListener.waiting=true

println "ACK Ready for disconnect"

// Wait to be connected and ACK the connection
while(waiterListener.waiting){
 println "Waiting for DIP disconnection..."
 Thread.sleep(500);
}

println "Waiting for DIP disconnection..."
// Wait for actual reconnection 
waitForConnection(waiterListener);




println "Finished listening, stopping subscriber process"
System.exit(0);


