import cern.dip.*


public class LocalListener implements DipSubscriptionListener{
	void handleMessage(DipSubscription subscription, DipData message){
		  println("Received data from subscription "+subscription.topicName)
		  float[] data = message.extractFloatArray("averageBunchIntensities");
		  println data[3560..3563]
		}
		
		void disconnected(DipSubscription subscription, String reason){
			  println("Disconnected from subscription "+subscription.topicName+" : "+reason)
		}
		
		
		void connected(DipSubscription subscription){
			  println("Connected to subscription "+subscription.topicName)
		}
		
		void handleException(DipSubscription subscription, Exception ex){
			  println("Exception on "+subscription.getTopicName()+" "+ex)
		}
}

println "starting"

m_df = Dip.create("simple-dip-client");

m_df.setDNSNode("dipns1");

ll = new LocalListener();

subscriptions = []
subscriptionNames = ["dip/acc/LHC/Beam/IntensityPerBunch/Beam1", "dip/acc/LHC/Beam/IntensityPerBunch/Beam2"]
subscriptionNames.each(){ subName ->
   subscriptions << m_df.createDipSubscription(subName, ll)
}
println "created "+subscriptions.size()+" subscriptions"


