import cern.dip.*

publisherName = "InfinitePublisher"+System.currentTimeMillis()
println "InfinitePublisher registered with server name "+publisherName

dipFactory = Dip.create(publisherName)

publications = []

public class LocalErrorHandler implements DipPublicationErrorHandler{
	public void handleException(DipPublication publication, DipException ex){
			println "Error :"+publication.getTopicName()+" "+ex.getMessage()	
	}
}

addShutdownHook {
    publications.each{ dipFactory.destroyDipPublication(it) }
    println ''
    println 'InfinitePublisher now stopped.'
}

dd = dipFactory.createDipData()
dd.insert("doubleVal", new Double(Double.MAX_VALUE))
dd.insert("integerVal", new Integer(Integer.MAX_VALUE))
dd.insert("booleanVal", new Boolean(true))
dd.insert("stringVal","MAX VALUE")
dd.insert("shortVal",new Short(Short.MAX_VALUE))
dd.insert("byteVal",new Byte(Byte.MAX_VALUE))
dd.insert("longVal",new Long(Long.MAX_VALUE))
dd.insert("floatVal",new Float(Float.MAX_VALUE))
refDate = new Date().getTime()

(1..100).each{
  publications << dipFactory.createDipPublication("dip/InfinitePublisher/pub"+it,new LocalErrorHandler())
}

println 'Infinite publisher is started.'
println 'Press Ctrl+C to stop it.'

while(true){
  ts = new DipTimestamp(refDate)
  publications.each{ it.send(dd, ts) }
  print '.'
  Thread.sleep(1000);
}

//	
