package cern.dip.implementation;

import cern.dip.*;
import junit.framework.*;


public class BadQualityTest extends TestCase{
    DipData sentData;
    int sentQuality;
    String sentQualityReason;
    boolean continueSending = false;


    public void testBadQualitySupport() throws DipException {
        DipFactory dip = Dip.create("TestPing");
        DipPublicationErrorHandler pubErrorHandler = new DipPublicationErrorHandler() {
            public void handleException(DipPublication publication, DipException ex) {
                System.out.println("Error handler for " + publication.getTopicName() + " called because " + ex.getMessage());
            }
        };
        DipPublication[] pub = new DipPublication[20];
        for (int i = 0; i < pub.length; i++) {
            String name = "dip.test.item" + i;
            System.out.println("Making publication " + name);
            pub[i] = dip.createDipPublication(name, pubErrorHandler);
        }
        // set up vars who's values are to be sent
        sentData = dip.createDipData();
        int intVal = 0;
        int countCycles = 0;
        try {
            while (countCycles < 3) {
                // send data via DIP
                sentQuality = DipQuality.DIP_QUALITY_UNINITIALIZED;
                sentQualityReason = "Its.broken!";
                for (int i = 0; i < pub.length; i++) {
                    sentQualityReason = "Its.broken! " + (intVal%2);
                    pub[i].setQualityBad(sentQualityReason);
                    System.out.println("Sent quality reason " + sentQualityReason);
                    Thread.sleep(200);
                }
                intVal++;
                countCycles++;
            }
        } catch (Exception e) {
            System.out.println("Failed to send data because " + e.getMessage());
            e.printStackTrace();
        }
        // shutdown
        for (int i = 0; i < pub.length; i++) {
          dip.destroyDipPublication(pub[i]);
        }
    }
}
