package cern.dip.implementation;

import junit.framework.*;
import cern.dip.*;


public class BasicTest extends TestCase{
    
    public void testBasicSubscription() throws Exception{
		DipFactory df = Dip.create("TestServer1");
		df.setDNSNode("localhost");
        DipSubscription sub = df.createDipSubscription("dip.test.item1", new SubListener());
        
        DipPublication pub = df.createDipPublication("dip/diptest/dip64", new DipPublicationErrorHandler() {
			public void handleException(DipPublication publication, DipException ex) {
				throw new RuntimeException(ex);
			}
		});
        DipData data = df.createDipData();
        data.insert("someval", "mtseet");
        pub.send(data, new DipTimestamp());
        
        sub.requestUpdate();
        
        Thread.sleep(10000);
        df.destroyDipSubscription(sub);
    }
    
    

    class SubListener implements DipSubscriptionListener{
    
        public void connected(DipSubscription subscription) {
            System.out.println("connected");
    
        }
    
        public void disconnected(DipSubscription subscription, String reason) {
            System.out.println("disconnected");
    
        }
    
        public void handleException(DipSubscription subscription, Exception ex) {
            System.out.println("handleException");
    
        }
    
        public void handleMessage(DipSubscription subscription, DipData message) {
            System.out.println("handleMessage");
    
        }
    
    }    
}



