package cern.dip.implementation;

import junit.framework.*;
import cern.dip.*;

public class TimeoutTest extends TestCase{
    
    public void testTimeout() throws Exception{
		//Create the publications
		DipFactory dip = Dip.create("TestTimeout");
        
        dip.setDNSNode("localhost");
        dip.setTimeout(5);


        assertEquals(5, dip.getTimeout());
        long ts = System.currentTimeMillis();;
        DipPublication pub = dip.createDipPublication("dip/test/TimeoutTest", new DipPublicationErrorHandler() {
			
			public void handleException(DipPublication publication, DipException ex) {
				fail("Received a DIP exception");
				
			}
		});
        
        assertNotNull(pub);
        
        System.out.println("Timing : "+((System.currentTimeMillis() - ts)/1000));
        
   //     Thread.sleep(8000);
        
	}

	class LocalSubscriptionHandler implements DipSubscriptionListener
	{
		public void handleMessage(DipSubscription subscription, DipData message)
		{
		
		}

		public void disconnected(DipSubscription subscription, String reason)
		{
			System.out.println(subscription.getTopicName()+" is "+reason);
		}
		public void connected(DipSubscription subscription)
		{
			System.out.println(subscription.getTopicName()+" connected");
		}

		public void handleException(DipSubscription subscription, Exception ex){
			System.out.println("Exception handler for " + subscription.getTopicName() + " called because " + ex.getMessage());
		}
	}

}
