package cern.dip;

/**
  * Indicates that an illegal or inappropriate argument has been passed to a
  * method.
  * <P>
  * A BadParameter exception provides a string describing the error. This is
  * used as the Java Exception message, available via the method getMessage.
  *
  */

public class BadParameter extends DipException
{

/**
  * Constructs a BadParameter exception with the specified error message.
  */
	public BadParameter(String msg) 
	{
		super("Bad Parameter - "+msg);
	}


 /**
  * Constructs a BadParameter exception.
  */
	public BadParameter()
	{
   		super("Bad Parameter"); 
	}
}
