package cern.dip;
/**
 * This interface enables asynchronous DIP errors to be reported.
 * Dip errors that can not be associated with any DIP method call are reported
 * through this interface.<p>
 * This interface must be implemented by the DIP developer.
 */
public interface DipPublicationErrorHandler{
    /**
     * invoked when an asynch error occurs.
     * @param publication source of the error
     * @param ex exception details.
     * */
	public abstract void handleException(DipPublication publication, DipException ex);
}

