package cern.dip;
/**
 * interface to encapsulate data quality flags
 */

public interface DipQuality {
  /**
  * Indicates the DataObject contains uninitialised data.
  */
  public final static int DIP_QUALITY_UNINITIALIZED = DipQualityEnum.UNINITIALIZED.intValue();	
	
  /**
   * Indicates that data can not be used. This only occurs when the publication is uninitialised.
   */
  public final static int DIP_QUALITY_BAD = DipQualityEnum.BAD.intValue();
  /**
   * Indicates that data can definitely be trusted. The last update attempt by the publisher was 
   * successfull and the value(s) that this quality corresponds to are the most current available.
   */
  public final static int DIP_QUALITY_GOOD = DipQualityEnum.GOOD.intValue();

  /**
   * Indicates that the last update attempt by the publisher had failed (the publication data source was
   * not accessible). The value(s) this quality corresponds to is the last known good value - however, the 
   * value can no longer be considered up-to-date.
   */
  public final static int DIP_QUALITY_UNCERTAIN = DipQualityEnum.UNCERTAIN.intValue();
}