package cern.dip;

public enum DipQualityEnum {
	UNINITIALIZED(-1), BAD(0), GOOD(1), UNCERTAIN(2);

	int m_value;

	DipQualityEnum(int intValue) {
		m_value = intValue;
	}

	public int intValue() {
		return m_value;
	}
	
	public static DipQualityEnum valueOf(int intValue){
		for (DipQualityEnum en : DipQualityEnum.values()) {
			if(en.intValue() == intValue){
				return en;
			}
		}
		throw new IllegalArgumentException("integer value "+intValue+" is not a valid DIP Quality integer value");
	}
}
