package cern.dip;
/**
* Interface for DIP subscriptions. DipSubscription objects are created by the {@link cern.dip.DipFactory DIP factory}.
 */
public interface DipSubscription {
  /**
   * Returns Name of the DipData item this object is subscribed to.
   */
  String getTopicName();

  /**
   * Requests last value to be re-send. This value will be received via the normal subscription
   * listener mechanism.
   */
  void requestUpdate();
}