package cern.dip;
/**
 * An optional interface for {@link cern.dip.DipPublication publishers} who are to re-read
 * the data source when a subscriber invokes their {@link cern.dip.DipSubscription#requestUpdate requestUpdate}
 * method.<p>
 */
public interface DipUpdateRequestListener {
  /**
   * Must be implemented to provide appropraite read of the data source. Data is to be returned through
   * the appropriate publication.sendX method.
   * @param publication identifies which publication this request refers to.
   */
  void handleUpdateRequest(DipPublication publication);
}