/*
 * Created on Aug 16, 2004
 *
 */
package cern.dip.implementation;

import cern.dip.DipBrowser;
import cern.dip.DipException;

/**
 * @author beharrel
 *
 */
public class DipBrowserImp implements DipBrowser {
	private int browserID = -2;
	
	private native int _create();
	private native void _destroy(int objectID);

	private native String[] _getPublications(int objectID, String pattern);
	private native String[] _getTags(int objectID, String pub) throws DipException;
	private native int 		_getType(int objectID, String tag) throws DipException;
	private native int 		_getSize(int objectID, String tag) throws DipException;


	public DipBrowserImp(){
		browserID = _create();
	}

	public void finalize(){
        if (browserID >= 0){
			_destroy(browserID);
        }
	}
	
	public String[] getPublications(String pattern) {
		return _getPublications(browserID, pattern);
	}

	
	public String[] getTags(String pub) throws DipException {
		return _getTags(browserID, pub);
	}


	public int getType() throws DipException {
		return getType(null);
	}

	
	public int getSize() throws DipException {
		return getSize(null);
	}


	public int getType(String tag) throws DipException {
		return _getType(browserID, tag);
	}


	public int getSize(String tag) throws DipException {
		return _getSize(browserID, tag);
	}

}
