package cern.dip.implementation;

import cern.dip.DipData;
import cern.dip.DipException;
import cern.dip.DipFactory;
import cern.dip.DipPublication;
import cern.dip.DipTimestamp;

public abstract class DipPublicationImpBase extends FactoryProduct implements DipPublication {

	/**
	 * Name of the publication
	 * */
	protected String name;

	public DipPublicationImpBase() {
		super();
	}
	
	protected abstract DipFactory getFactory();
	protected abstract void sendData(DipData data, DipTimestamp timestamp) throws DipException ;

	public String getTopicName() {
		return name;
	}

	public void send(double value, DipTimestamp timestamp) throws DipException {
		DipData data = getFactory().createDipData();
		data.insert(value);
		sendData(data, timestamp);
	}


	public void send(double[] value, DipTimestamp timestamp) throws DipException {
		DipData data = getFactory().createDipData();
		data.insert(value);
		sendData(data, timestamp);
	}

	public void send(short value, DipTimestamp timestamp) throws DipException {
		DipData data = getFactory().createDipData();
		data.insert(value);
		sendData(data, timestamp);
	}

	public void send(short[] value, DipTimestamp timestamp) throws DipException {
		DipData data = getFactory().createDipData();
		data.insert(value);
		sendData(data, timestamp);
	}

	public void send(int value, DipTimestamp timestamp) throws DipException {
		DipData data = getFactory().createDipData();
		data.insert(value);
		sendData(data, timestamp);
	}

	public void send(int[] value, DipTimestamp timestamp) throws DipException {
		DipData data = getFactory().createDipData();
		data.insert(value);
		sendData(data, timestamp);
	}

	public void send(float value, DipTimestamp timestamp) throws DipException {
		DipData data = getFactory().createDipData();
		data.insert(value);
		sendData(data, timestamp);
	}

	public void send(float[] value, DipTimestamp timestamp) throws DipException {
		DipData data = getFactory().createDipData();
		data.insert(value);
		sendData(data, timestamp);
	}

	public void send(long value, DipTimestamp timestamp) throws DipException {
		DipData data = getFactory().createDipData();
		data.insert(value);
		sendData(data, timestamp);
	}

	public void send(long[] value, DipTimestamp timestamp) throws DipException {
		DipData data = getFactory().createDipData();
		data.insert(value);
		sendData(data, timestamp);
	}

	public void send(byte value, DipTimestamp timestamp) throws DipException {
		DipData data = getFactory().createDipData();
		data.insert(value);
		sendData(data, timestamp);
	}

	public void send(byte[] value, DipTimestamp timestamp) throws DipException {
		DipData data = getFactory().createDipData();
		data.insert(value);
		sendData(data, timestamp);
	}

	public void send(boolean value, DipTimestamp timestamp) throws DipException {
		DipData data = getFactory().createDipData();
		data.insert(value);
		sendData(data, timestamp);
	}

	public void send(boolean[] value, DipTimestamp timestamp) throws DipException {
		DipData data = getFactory().createDipData();
		data.insert(value);
		sendData(data, timestamp);
	}

	public void send(String value, DipTimestamp timestamp) throws DipException {
		DipData data = getFactory().createDipData();
		data.insert(value);
		sendData(data, timestamp);
	}

	public void send(String[] value, DipTimestamp timestamp) throws DipException {
		DipData data = getFactory().createDipData();
		data.insert(value);
		sendData(data, timestamp);
	}

}