/*
 * Created on Aug 26, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package cern.dip.implementation;

import cern.dip.*;

/**
 * @author beharrel
 *
 */
abstract public class FactoryProduct {
	
	/**
	* set to true when the object has been destroyed
	* */
	protected boolean destroyed = false;
	
	
	/**
	* @return true is object has been passed to the factory for destruction
	*/
	public boolean isDestroyed() {
		return destroyed;
	}
	
	
	/**
	* Mark object as destoyed - will cause the C++ representation to be removed 
	*/
	abstract protected void setDestroyed();
	
	
	/**
	* Make sure the object is not been used after it has been based to destroy
	* */
	protected void validate() throws DipException{
		if (isDestroyed()){
			throw new DipException("Object has been already been sent to factory for destruction");
		}
	}

}
