/*
 * Created on Jul 14, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package cern.dip.implementation;

import java.io.Serializable;
import java.util.Arrays;

import cern.dip.DipData;

/**
 * @author beharrel
 * Holds information about fields of a DIP publication.
 */
class Field implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 4454668949730715050L;
	
		/// The data held in the field
		public Object data;
		/// The field name
		final public String fieldName;
		/// the field type 
		final public int fieldType;
		/// tells us how many elements there are
		final public int cardinality;
		
		/**
		 * @param theData can not change
		 * */
		public Field(Object theData, final String theFieldName, final int theFieldType, final int noElements){
			data = theData;
			fieldName = new String(theFieldName);
			fieldType = theFieldType;
			cardinality = noElements;
		}
		
		public Field(final String theFieldName, final int theFieldType, final int noElements){
			data = null;
			fieldName = new String(theFieldName);
			fieldType = theFieldType;
			cardinality = noElements;
		}
		
		public boolean equals(Field other){
			if ((this.cardinality != other.cardinality) && 
				(!this.fieldName.equals(other.fieldName)) &&
				(this.fieldType != other.fieldType)){
					return false;
				}
			if ((this.fieldType < 10) && !this.data.equals(other.data)){
				return false;
			}else{
				// its an array.
				switch(this.fieldType){
					case DipData.TYPE_BOOLEAN_ARRAY:{
						boolean [] value = (boolean []) this.data;
						boolean [] otherValue = (boolean []) other.data;
						if (!Arrays.equals(value,otherValue)){
							return false;
						}
						break;
					}
					
					case DipData.TYPE_BYTE_ARRAY:{
						byte [] value = (byte []) this.data;
						byte [] otherValue = (byte []) other.data;
						if (!Arrays.equals(value,otherValue)){
							return false;
						}
						break;
					}
					
					case DipData.TYPE_DOUBLE_ARRAY:{
						double [] value = (double []) this.data;
						double [] otherValue = (double []) other.data;
						if (!Arrays.equals(value,otherValue)){
							return false;
						}
						break;
					}
					
					case DipData.TYPE_FLOAT_ARRAY:{
						float [] value = (float []) this.data;
						float [] otherValue = (float []) other.data;
						if (!Arrays.equals(value,otherValue)){
							return false;
						}
						break;
					}
					
					case DipData.TYPE_INT_ARRAY:{
						int [] value = (int []) this.data;
						int [] otherValue = (int []) other.data;
						if (!Arrays.equals(value,otherValue)){
							return false;
						}
						break;
					}
					
					case DipData.TYPE_LONG_ARRAY:{
						long [] value = (long []) this.data;
						long [] otherValue = (long []) other.data;
						if (!Arrays.equals(value,otherValue)){
							return false;
						}
						break;
					}
					
					case DipData.TYPE_SHORT_ARRAY:{
						short [] value = (short []) this.data;
						short [] otherValue = (short []) other.data;
						if (!Arrays.equals(value,otherValue)){
							return false;
						}
						break;
					}
					
					case DipData.TYPE_STRING_ARRAY:{
						String [] value = (String []) this.data;
						String [] otherValue = (String []) other.data;
						if (!Arrays.equals(value,otherValue)){
							return false;
						}
						break;
					}
				}
			}	
				
				
			return true;
		}
}
