package cern.dip.mock;

import java.util.HashSet;
import java.util.Set;
import java.util.regex.Pattern;

import cern.dip.DipBrowser;
import cern.dip.DipException;

public class MockDipBrowser implements DipBrowser {

	public MockDipFactory dipFactory;

	@Override
	public String[] getPublications(String pattern) {
		Set<String> result = new HashSet<>();
		Set<String> publications = dipFactory.m_publicationNameToSubscription.keySet();
		
		Pattern rePattern = Pattern.compile(pattern.replace("*", ".*"));
		
		for (String pub : publications) {
			if(rePattern.matcher(pub).matches()){
				result.add(pub);
			}
		}
		return result.toArray(new String[]{});
	}

	@Override
	public String[] getTags(String pub) throws DipException {
		throw new UnsupportedOperationException();
	}

	@Override
	public int getType() throws DipException {
		throw new UnsupportedOperationException();
	}

	@Override
	public int getSize() throws DipException {
		throw new UnsupportedOperationException();
	}

	@Override
	public int getType(String tag) throws DipException {
		throw new UnsupportedOperationException();
	}

	@Override
	public int getSize(String tag) throws DipException {
		throw new UnsupportedOperationException();
	}

}
